import { IKeyObjectValue } from "../../type";
import { Barstate, Strategy, Syminfo, Ta } from './buildInVarNamespace';
export declare class BuiltInVariables extends Ta {
    private _cacheData;
    private _barIndex;
    _isRealTimeBar: boolean;
    private _barstate;
    private _priceVariables;
    private _lastBarIndex;
    private _currentBarTime;
    private _lastBarTime;
    private _period;
    _offsetTime: number;
    private _strategy;
    private _multiplier;
    private _unit;
    syminfo: Syminfo;
    private _timeTradingday?;
    private _mintick?;
    private _cacheSpace;
    private _precision?;
    private _nextBarTime?;
    _isRepeated?: boolean;
    __requestName: string;
    __isFirstRun: boolean;
    private _maxBarsBack;
    private _maxBarsBackOfKey;
    __isReqRepeated?: boolean;
    current_time?: number;
    private _preBarTime?;
    isfutures?: boolean;
    hasNightSession?: boolean;
    private _tradeSessions?;
    private _openTime?;
    private _preTime?;
    constructor(id: string);
    getVarCacheData(): {
        cacheData: IKeyObjectValue;
        cacheSpace: IKeyObjectValue;
        taCacheData: IKeyObjectValue;
        barstateCacheData: IKeyObjectValue;
        strategyCacheData: IKeyObjectValue;
        offsetTime: number;
        isfutures: boolean | undefined;
        hasNightSession: boolean | undefined;
        tradeSessions: IKeyObjectValue[] | undefined;
        preBarTime: number | undefined;
        syminfo: IKeyObjectValue;
        preTime: number | undefined;
        preBarIndex: number;
    };
    setVarCacheData(data: IKeyObjectValue): void;
    get bar_index(): number;
    get n(): number;
    get na(): undefined;
    get volume(): number;
    get close(): number;
    get low(): number;
    get open(): number;
    get high(): number;
    get ohlc4(): number;
    get hl2(): number;
    get hlc3(): number;
    get hlcc4(): number;
    get timenow(): number;
    get time(): number;
    get time_open(): number;
    private _getStartTime;
    get hour(): number;
    get minute(): number;
    get second(): number;
    get month(): number;
    get year(): number;
    get dayofweek(): number;
    get dayofmonth(): number;
    get weekofyear(): number;
    get barstate(): Barstate;
    get strategy(): Strategy;
    get ticker(): any;
    get tickerid(): any;
    get isdaily(): boolean;
    get isdwm(): boolean;
    get isintraday(): boolean;
    get isminutes(): boolean;
    get ismonthly(): boolean;
    get isseconds(): boolean;
    get isweekly(): boolean;
    get period(): string;
    get interval(): number;
    get last_bar_index(): number;
    get last_bar_time(): number;
    get time_tradingday(): number;
    get mintick(): number | undefined;
    get __period(): string;
    get precision(): number | undefined;
    get nextBarTime(): number | undefined;
    set max_bars_back(count: number);
    getTimeTradingday(time: number, period: string): number;
    private _getTimeTradingday;
    updateOptions(options: IKeyObjectValue): void;
    updateData(data: IKeyObjectValue, isRepeated?: boolean): void;
    getCacheData(key: string, preIndex: number, value: any): any;
    setCacheData(key: string, value: any): any;
    __setBarsBackOfKey(key: string, val: number): void;
    __getBarsBackOfKey(key: string): any;
    private _cacheCopy;
    add(val1: any, val2: any): any;
    sub(val1: any, val2: any): number | any[];
    div(val1: number, val2: number): number | undefined;
    notEqual(val1: any, val2: any, type1: string, type2: string): boolean;
    equal(val1: any, val2: any, type1: string, type2: string): boolean | undefined;
    compareDataHandle(val: any): any;
}
